{$DEFINE TEST}
(*{$UNDEF TEST}*)
(*{$DEFINE SCR}*)
{$UNDEF SCR}

  unit elvmicro;

  INTERFACE
  uses NewDelay, TPCrt, DOS
  {$IFDEF TEST}
  ,TPDate
  {$ENDIF};

  const
       MaxLenTxtCheck  = 24;
       {⠩-}
       wACKstart=500;{ENQ --> ACK}
       wData=2000;   {ACK --> STX <data> ETX CRT}
       wACKend=500;  {STX <data> ETX CRT --> ACK}
       wEOT=500;     {ACK --> EOT}
       wCmd=2000;    {command processing time}
       wRcv=500;     {two data bytes receave time-out}
       wWait=500;    {wait time when collision occured}
       wSend=20;  {pause between two data bytes}
      {ᮮ饭  訡( )}
       errAllOk        = 0  ;  {訡 }
       errCtrlRepOk    = -1  ;
       errZeroRepOK    = -2  ;
       errBadPrice     = -8  ;
       errBadKol       = -10 ;
       errNulPrice     = -11 ;
       errBadCmd       = -102;
       errNoPaper      = -103;  { 㬠}
       errPswInPrg     = -112;
       errTotalLessRet = -115;
       errPrintInPrg   = -116;
       errBadDiscount  = -123;
       errOpPermitted  = -124;
       errBadSection   = -125;
       errBadType      = -126;
       errMulOverflow  = -127;
       errCmdDisabled  = -128;
       errCheckSumOverflow = -129;
       errReportDone   = -131;
       errCtrlRepOverflow = -132;
       errSmallSum     = -134;
       errRetCheckOpened = -135;
       err24h          = -136;
       errDiscountDisabled = -138;
       errAnnAndRetInCheck = -139;
       errBadPassword  = -140;
       errCtrlRepBufferIsNotFull = -141;
       errCtrlRepPrinting = -142;
       errZeroDone     = -143;
       errZeroRepPrinting = -144;
       errBadTable     = -145;
       errBadRow       = -146;
       errBadCol       = -147;
       errBadDate      = -148;
       errBadTime      = -149;
       errSmallCheckSum = -150;
       errRetSumCalc   = -151;
       errNoMoneyForOutcom = -152;
       errClosedCheck  = -154;
       errOpenedCheck  = -155;
       errOpenedSmena  = -156;
       errECRBlocked   = -157;
       errNumberExists = -158;
       errReRegisration = -159;
       errFMError      = -160;
       errFMWriteError = -161;
       errInvalidSmena  = -162;
       errInvalidReportType = -163;
       errInvalidPassword = -164;
       errInvalidNumber = -165;
       errInvalidRegNum = -166;
       errInvalidINN    = -167;
      {訡 ࠩ (ணࠬ)}
       errBadInterface  = -200;
       errNoAnswer      = -201;
       errPort          = -202;
       errRcvTimeOut    = -203;

Type
   TReplyBuffer=record
   CASE byte Of
   0:(RB:array[1..100]of byte);
   1:(RHU        :Char;
      Error      :Byte;
      Zero       :Byte);
   2:(RHD        :Char;
      Cassir     :Byte;
      ECRNum     :Byte;
      YY         :Byte;
      MM         :Byte;
      DD         :Byte;
      H          :Byte;
      M          :Byte;
      S          :Byte;
      Fisc       :Byte;
      ProdNum    :LongInt;
      ECRType    :Byte;
      ROMVer     :array [1..2]of char;
      CurMode    :Byte;
      PswRequired:Byte;
      CheckNum   :Word;
      SmenaNum   :Word;
      CheckState :Byte;
      CheckSum   :LongInt;
      DecPointPos:Byte;
      LastError  :Byte;);
   3:(RHM:Char;
      Money:comp;
      );
   End;
{㤮}
Procedure Beep(Com:Byte);
{室  ०}
Procedure Menu(Com:Byte);
{室  ०}
Function  Password(Com,Mode:Byte;Psw:Longint): byte;
{ ப}
Function PrintString(Com:byte; Stroka:string): byte;
{஢ }
Function BlockKeyboard(Com:Byte;Block:Boolean):byte;
{뢮  ᯫ ப}
Function DisplayString(Com:Byte; Stroka:string):Byte;
{}
Function GetState(Com:byte):byte;
{}
Function SetTime(Com:Byte;H,M,S:Byte):byte;
{}
Function SetDate(Com:Byte;D,M,Y:Byte):byte;
{}
Function GetLastError(Com:Byte; Var LastError:Byte):Byte;
{}
Function Income(Com:Byte;Sum:LongInt):Byte;
{}
Function Outcome(Com:Byte;Sum:LongInt):Byte;
{}
Function Discount(Com:Byte;Percent:Byte):Byte;
{}
Function Upcount(Com:Byte;Percent:Byte):Byte;
{⨥ 祪  祩 (1                 Money=0 - ᤠ  }
Function CloseCheck(Com, PaymentType: byte; Money: longint): byte;
{ॣ  ⨥ 祪}
Function RegWithClose(Com,Sek: byte; Price: longint; Kol:real ): byte;
{ॣ   祪}
Function Reg(Com,Sek: byte; Price: longint; Kol:real): byte;
{ }
Function Total(Com:byte): comp;
{୮}
Function Storno(Com,Sek: byte; Price: longint; Kol:real):Byte;
{}
Function Ret(Com: byte; Price: longint; Kol:real ): byte;
{}
Function RetWithClose(Com: byte; Price: longint; Kol:real ): byte;
{㫨஢}
Function Ann(Com: byte; Price: longint; Kol:real ): byte;
{㫨஢}
Function AnnCheck(Com: byte): byte;
{஬ ⮣}
Function PS(Com:byte): byte;
{  祪}
Function NumCheck(Com:byte): longint;
{  }
Function NumZaw(Com:byte): longint;

Var RB:TReplyBuffer;{receave buffer}
    Error:Integer;

IMPLEMENTATION
Const
    COMNum:Byte=1;
    COM_SPEED:Byte=4;

    SBLen=100;
    RBLen=100;
 { Control symbols}
    ENQ=$05;
    ACK=$06;
    STX=$02;
    ETX=$03;
    EOT=$04;
    NAK=$15;
    DLE=$10;

 { COM port operations }
    coInit=0;
    coOut=1;
    coIn=2;
    coStatus=3;
 {ECR commands}
    ComPsw         =$56;
    ComMenu        =$48;
    {}
    ComPrintStr    =$4c;
    ComBlockKbd    =$42;
    ComBeep        =$47;
    ComDisplayStr  =$2e;
    ComECRState    =$3f;
    ComSetTime     =$4b;
    ComLastError   =$45;
    {}
    ComIncome      =$49;
    ComOutcome     =$4f;
    ComDiscount    =$43;
    ComUpcount     =$44;
    ComClose       =$4a;
    ComSub         =$53;
    ComTotal       =$4d;
    ComReg         =$52;
    ComStorno      =$4e;
    ComAnn         =$41;
    ComRet         =$57;
    ComAnnCheck    =$59;
    {}
    ComSetDate     =$54;
    ComNULLStart   =$54;
    ComNULL        =$5a;
    ComNULLEnd     =$58;
    {}
    ComProgTable   =$50;
    ComReadTable   =$46;
    {}
    ComSetNumber   =$61;
    ComFiscalization =$62;
    ComGetDates    =$63;
    ComFiscRepDate =$65;
    ComFiscRepSmen =$66;

Var PortAdr:Word;

    BUF:Byte; {port buffer}
    SB:array[1..SBLen] Of Byte;{send buffer}
    BytesToSend:LongInt;
{**************************************************************************}
Procedure ClearSB;
Var i:Integer;
Begin
  For i:=1 to SBLen Do SB[i]:=0;
End;

Procedure ClearRB;
Var i:Integer;
Begin
  For i:=1 to 30 Do RB.RB[i]:=0;
End;

Function BiosCom(Op,Par,Num:Byte):word;
Var Res:Word;
Begin
asm
   xor ax,ax
   mov al,num
   mov dx,ax
   dec dx
   mov ah,op
   mov al,par
   int 14h
   mov res,ax
End;
BiosCom:=res;
End;
{**************************************************************************}
  {---樠 Com -----}
Procedure InitCom(prt,s: byte);
Var param,cl :byte;
Begin
   case s of
   1: param:=$83;   {10000011b; {1200}
   2: param:=$A3;   {10100011b; {2400}
   3: param:=$C3;   {11000011b; {4800}
   4: param:=$E3;   {11100011b; {9600}
   else param:=$C3; {11000011b; {4800}
   end;
   COMNum:=prt;
   COM_SPEED:=s;
   BiosCom(coInit,param,COMNum);
   PortAdr:=Memw[($0000):($0400+(prt-1)*2)];
   Port[PortAdr+4]:=1;  {⨢㥬 DTR}
  {--  ।饣 ﭨ ਥ (      }
   cl:=Port[PortAdr+5];
   cl:=Port[PortAdr];
end;

Procedure Init(Com:Byte);
Begin
  ClearSB;ClearRB;
  InitCom(Com,COM_SPEED);
End;

Function Send(x:Byte;W:Integer):Boolean;
Var i:Word;
    TimeEnd:Byte;
Begin
  repeat until (port[PortAdr+5] and $20)=$20;
  Port[PortAdr]:=x;
  TimeEnd := Mem[$0040:$006c] + (50 div 56 +1); { 砫쭮 ६ }
  Repeat
    If (port[PortAdr+5] and $60)=$60 Then Break;
    If Mem[$0040:$006c]=TimeEnd Then Break;
  Until False;
  If (port[PortAdr+5] and $60)=$60 Then Error:=errAllOK
  Else Error:=errBadInterface;
  Send:=(Error=errAllOK);
  delay (W);
End;
{**************************************************************************}
Function Rcv(TimeOut:Integer{;
             ByteToCheck:byte;
             Check:Boolean}):Boolean; {ਥ }
Var i:word;
    TimeEnd:Byte;
Begin
  TimeEnd := Mem[$0040:$006c] + (TimeOut div 56+1); { 砫쭮 ६ }
  Repeat
    If (Port[PortAdr+5] and $01)=$01 Then Break;
    If Mem[$0040:$006c]=TimeEnd Then Break;
  Until False;
  If (Port[PortAdr+5] and $01)=1 Then
  Begin
    If (Port[PortAdr+5] and $0E)=0 Then
    Begin
      Buf:=Port[PortAdr];
      Error:=errAllOK;
    End Else Error:=errPort;
  End Else Error:=errRcvTimeOut;
  Rcv:=(Error=errAllOK);
End;
{**************************************************************************}
Procedure Session(GetAnswer:Boolean);
Label ACKSend,
      STXRcv,
      NoAnswer,
      DataRcv;
Var FRC,RC:Integer;
    ACK_OK,
    ENQ_OK,
    STX_OK,
    ETX_OK,
    DLE_OK,
    EOT_OK:Boolean;
    RCount,i:Integer;
    CRC:byte;
 {$IFDEF TEST}
    F:Text;
 {$ENDIF}
Begin
 {$IFDEF TEST}
 {$IFDEF SCR}
  ClrScr;
  AssignCrt(F);
 {$ELSE}
  Assign(F,'111');
 {$ENDIF}
  {$I-}
  Append(F);
  If IOResult<>0 Then Rewrite(F);
  WriteLn(F,'!!!---',DateToDateString('dd/mm/yyyy',Today),'---!!!');
  WriteLn(F,'!!!---',TimeToTimeString('hh/mm/ss',CurrentTime),'---!!!');
  {$I+}
 {$ENDIF}
  {start session}
  FRC:=0;
  REPEAT {when answer was ENQ (i.e. collision) or dirt, we are here}
    Inc(FRC);
    RC:=0;
    REPEAT {try 5 times to send ENQ if ECR answer is NAK or no answer at all}
      Inc(RC); ACK_OK:=False;
     {$IFDEF TEST}
      WriteLn(F,'ENQ-->');
     {$ENDIF}
      Send(ENQ,0);
      If Rcv(wACKstart) Then
      Begin
        CASE BUF OF
      ACK:Begin {ACK receaved !!!}
            ACK_OK:=True;
           {$IFDEF TEST}
            WriteLn(F,'<--ACK');
           {$ENDIF}
            Break;
          End;
      ENQ:Begin {Collision}
            Delay(wWait);
            Break;
          End;
      NAK:Begin
            Delay(wWait);
          End;
        END;
      End;
    UNTIL RC>5;
  UNTIL (FRC=100)or(ACK_OK)or(RC>5);
  If not ACK_OK Then
  Begin {session is not started}
    Send(EOT,0); Error:=errBadInterface;
   {$IFDEF TEST}
    WriteLn(F,Error);
   {$ENDIF}
    Exit;
  End;

  {sesson started. send data.}
  RC:=0; ACK_OK:=False; ENQ_OK:=False;
  REPEAT
    Inc(RC);
    For i:=1 to BytesToSend Do
    Begin
      Send(SB[i],wSend);
     {$IFDEF TEST}
      WriteLn(F,'DATA:',i,'-->');
     {$ENDIF}
    End;
    If Rcv(wACKend) Then
      CASE BUF OF
     ACK:Begin
           ACK_OK:=True;{data transmission OK}
          {$IFDEF TEST}
           WriteLn(F,'<--ACK');
          {$ENDIF}
         End;
     ENQ:If (RC>1)or(SB[2]=ComDisplayStr) Then
         Begin
           ENQ_OK:=True;{data transmission OK. ECR session request}
          {$IFDEF TEST}
           WriteLn(F,'<--ENQ');
          {$ENDIF}
         End;
     {$IFDEF TEST}
     ELSE WriteLn(F,'<--not ACK or ENQ: ',BUF)
     {$ENDIF}
     END{$IFDEF TEST}
     Else WriteLn(F,'<--NO ANSWER')
     {$ENDIF};
  UNTIL (RC>10)or(ACK_OK)or(ENQ_OK);
  Send(EOT,0);
  {$IFDEF TEST}
    WriteLn(F,'EOT-->');
  {$ENDIF}
  If not (ACK_OK or ENQ_OK) Then
  Begin {no answer from ECR after data transmission}
    Error:=errBadInterface;
   {$IFDEF TEST}
    WriteLn(F,Error);
   {$ENDIF}
    Exit;
  End;

  If not GetAnswer Then
  Begin
    Error:=errAllOK;
    Exit;
  End;

  {ECR have got data !!! Listen for ECR replye if not until}
  If not ENQ_OK Then
  Begin
    RC:=0;
    REPEAT
      Inc(RC);
      If not Rcv(wCmd) Then Break;
      If BUF=ENQ Then
      Begin {ENQ receaved !!!}
        ENQ_OK:=True;
        {$IFDEF TEST}
        WriteLn(F,'<--ENQ');
        {$ENDIF}
        Break;
      End;
    UNTIL RC>100;
    If not ENQ_OK Then Goto NoAnswer;{no request from ECR}
  End;

  {ECR requests session. receave STX}
  FRC:=0;
  REPEAT
   {$IFDEF TEST}
    WriteLn(F,'ACK-->');
    {$ENDIF}
    Send(ACK,0);
STXRcv:
    RC:=0; STX_OK:=False;
    REPEAT
      Inc(RC);
      If not Rcv(wData) Then Goto NoAnswer{no any data from ECR}
      Else
      CASE BUF OF
     STX: Begin
           {$IFDEF TEST}
            WriteLn(F,'<--STX');
            {$ENDIF}
            STX_OK:=True;
            Break;
          End;
     ENQ: Break;
      END;
    UNTIL (RC>100);
    If not STX_OK Then Inc(FRC) Else Break;
  UNTIL (FRC>10)or(STX_OK);
  If not STX_OK Then  Goto NoAnswer;{data header not receaved}

  {STX is on OK. receave data body}
DataRcv:
  ETX_OK:=False;
  i:=1; CRC:=0;
  REPEAT
    DLE_OK:=False;
    If not Rcv(wData) Then Goto NoAnswer {receave time out}
    Else
    Begin
      If DLE_OK Then DLE_OK:=False
      Else If BUF=DLE Then DLE_OK:=True
           Else If BUF=ETX Then
           Begin
             ETX_OK:=True;
             If not Rcv(wRcv) Then
             Begin
               Inc(FRC);
               If FRC>10 Then Goto NoAnswer
               Else Goto STXRcv;
             End Else
             Begin
               CRC:=CRC xor ETX;
               RB.RB[i]:=ETX;
              {$IFDEF TEST}
               WriteLn(F,'<--DATA:',i,' ETX CRC=',CRC);
               {$ENDIF}
               Inc(i);
               RB.RB[i+1]:=BUF;
              {$IFDEF TEST}
               WriteLn(F,'<--CRC: ',BUF);
              {$ENDIF}
               Break;
             End;
           End;
      If not DLE_OK Then
      Begin
        RB.RB[i]:=BUF; Inc(i);
      End;
      CRC:=CRC xor BUF;
      {$IFDEF TEST}
      WriteLn(F,'<--DATA:',i-1,' ',BUF,' CRC:',CRC);
      If DLE_OK Then WriteLn(F,'!!!---WAS MASKED WITH DLE---!!!');
      {$ENDIF}
    End;
  UNTIL (i>RBLen)or(ETX_OK);

  If not ETX_OK Then
  Begin
    Inc(FRC);
    If FRC>10 Then Goto NoAnswer
    Else Goto STXRcv;
  End;

  {CRC:=0; RCount:=i;
  For i:=1 to RCount Do CRC:=CRC xor RB.RB[i];
 }If CRC=BUF Then
  Begin
    Send(ACK,0);
    If Rcv(wEOT) Then
    Begin
      If BUF=STX Then
      Begin
        Inc(FRC);
        If FRC>10 Then Goto NoAnswer
        Else Goto DataRcv;
      End;
      If BUF<>EOT Then
      Begin
        If Rcv(200) Then
        Begin
          Inc(FRC);
          If FRC>10 Then Goto NoAnswer
          Else Goto STXRcv;
        End;
      End;
    End;
    If RB.RHU='U' Then Error:=-RB.Error Else Error:=errAllOK;
  End Else
  Begin {CRC Error}
    Send(NAK,0);
    Inc(FRC);
    If FRC>10 Then Goto NoAnswer
    Else Goto STXRcv;
  End;
  {$IFDEF TEST}
  Close(F);
  {$ENDIF}
  Exit;
NoAnswer:
Begin
  Error:=errNoAnswer;
  {$IFDEF TEST}
  Close(F);
  {$ENDIF}
  Exit;
End
End;

{************************************************************************}

Procedure ConvBCD1ToByte(Var B:Byte);
Var h:Byte;
Begin
  h:=B;
  B:=((h and $F0)div 16)*10;
  B:=B+h and $0F;
End;

Procedure ConvBCD2ToWord(Var B:Word);
Type a2=array [1..2] of byte;
Var h:^a2;
    hB:Word;
    K:Integer;
Begin
  h:=Addr(B);
  hB:=0;
  K:=1000;
  hB:=hB+((h^[1] and $f0)div 16)*K;   K:=K div 10;
  hB:=hB+((h^[1] and $0f))*K;         K:=K div 10;
  hB:=hB+((h^[2] and $f0)div 16)*K;   K:=K div 10;
  hB:=hB+((h^[2] and $0f))*K;
  B:=hB;
End;

Procedure ConvBCD4ToLongint(Var B:LongInt);
Var h:array [1..4] of byte;
    k:LongInt;
Begin
  h[1]:=(B and $000000FF);
  h[2]:=(B and $0000FF00) div $100;
  h[3]:=(B and $00FF0000) div $10000;
  h[4]:=(B and $FF000000) div $1000000;
  B:=0;
  K:=10000000;
  B:=B+((h[1] and $f0)div 16)*K;   K:=K div 10;
  B:=B+((h[1] and $0f))*K;         K:=K div 10;
  B:=B+((h[2] and $f0)div 16)*K;   K:=K div 10;
  B:=B+((h[2] and $0f))*K;         K:=K div 10;
  B:=B+((h[3] and $f0)div 16)*K;   K:=K div 10;
  B:=B+((h[3] and $0f))*K;         K:=K div 10;
  B:=B+((h[4] and $f0)div 16)*K;   K:=K div 10;
  B:=B+((h[4] and $0f))*K;
End;

Procedure ConvBCD8ToComp(Var B:comp);
Type a1=array [1..8] of Byte;
Var k:Comp;
    p1:^a1;
    h:Comp;
Begin
  p1:=Addr(B);
  h:=0;
  K:=1000000000000000.0;
  h:=h+((p1^[1] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[1] and $0f))*K;         K:=K/10;
  h:=h+((p1^[2] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[2] and $0f))*K;         K:=K/10;
  h:=h+((p1^[3] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[3] and $0f))*K;         K:=K/10;
  h:=h+((p1^[4] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[4] and $0f))*K;         K:=K/10;
  h:=h+((p1^[5] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[5] and $0f))*K;         K:=K/10;
  h:=h+((p1^[6] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[6] and $0f))*K;         K:=K/10;
  h:=h+((p1^[7] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[7] and $0f))*K;         K:=K/10;
  h:=h+((p1^[8] and $f0)div 16)*K;   K:=K/10;
  h:=h+((p1^[8] and $0f))*K;
  B:=h;
End;

Procedure CorrectSB(Var Len,CRC:Byte);
Var i,j,c:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  For i:=1 to SBLen Do hSB[i]:=0;
  C:=STX;j:=1;
  For i:=1 to Len Do
  Begin
    If SB[i] in [DLE,ETX] Then
    Begin
      hSB[j]:=DLE;
      Inc(j); C:=C xor DLE;
    End;
    hSB[j]:=SB[i];
    Inc(j);
    C:=C xor SB[i];
  End;
  For i:=1 to SBLen Do SB[i]:=hSB[i];
  Len:=j-1; CRC:=C;
End;

{************************************************************************}

{㤮}
Procedure Beep(Com:Byte);
Var i:Integer;
    CRC:Byte;
Begin
  Init(Com);
  BytesToSend:=4;
  SB[1]:=STX; SB[2]:=ComBeep; SB[3]:=ETX; SB[4]:=ETX xor ComBeep;
  Session(False);
End;
{室  ०}
Procedure Menu(Com:Byte);
Var i:Integer;
    CRC:Byte;
Begin
  Init(Com);
  BytesToSend:=4;
  SB[1]:=STX; SB[2]:=ComMenu; CRC:=SB[2];
  SB[3]:=ETX; SB[4]:=CRC xor ETX;
  Session(True);
End;
{}
Function Password(Com,Mode:Byte;Psw:LongInt):byte;
Var i,hPos,CRC:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComPsw;SB[3]:=Mode;
  i:=Psw mod 10000000 div 1000000; SB[4]:=i;
  i:=Psw mod 1000000 div 100000;   SB[5]:=i;
  i:=Psw mod 100000 div 10000;     SB[5]:=SB[5]*16+i;
  i:=Psw mod 10000 div 1000;       SB[6]:=i;
  i:=Psw mod 1000 div 100;         SB[6]:=SB[6]*16+i;
  i:=Psw mod 100 div 10;           SB[7]:=i;
  i:=Psw mod 10;                   SB[7]:=SB[7]*16+i;

  hPos:=7;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Password:=Error;
End;
{ ப}
Function PrintString(Com:byte; Stroka:string): byte;
Var i,j:Integer;
    CRC:Byte;
    StrLen:Byte;
begin
  Init(Com);
  StrLen:=Length(Stroka);
  SB[1]:=STX;
  SB[2]:=ComPrintStr;
  j:=3; CRC:=ComPrintStr;
  For i:=1 to StrLen Do
  Begin
    If Ord(Stroka[i]) in [DLE,ETX] Then
    Begin
      SB[j]:=DLE;
      Inc(j);
    End;
    SB[j]:=Ord(Stroka[i]); CRC:=CRC xor SB[j];
    Inc(j);
  End;
  SB[StrLen+3]:=ETX;
  SB[StrLen+4]:=CRC xor ETX;
  BytesToSend:=StrLen+4;
  Session(True);
  PrintString:=Error;
end;
{஢ }
Function BlockKeyboard(Com:Byte;Block:Boolean):byte;
Begin
  Init(Com);
  SB[1]:=STX;
  SB[2]:=ComBlockKbd;If Block Then SB[3]:=1 Else SB[3]:=0;
  SB[4]:=ETX; SB[5]:=ComBlockKbd xor ETX xor SB[3];
  BytesToSend:=5;
  Session(True);
  BlockKeyboard:=Error;
End;
{뢮  ᯫ ப}
Function DisplayString(Com:Byte; Stroka:string):Byte;
Var b,i:Byte;
    hPos,CRC:Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComDisplayStr;
  b:=3; i:=1;
  While (i<=8)and(i<=Length(Stroka)) Do
  Begin
    Case Stroka[i] Of
    '': SB[i+2]:=$AF;
    '': SB[i+2]:=$BE;
    '': SB[i+2]:=$BF;
    '': SB[i+2]:=$0E;
    '': SB[i+2]:=$9E;
    '': SB[i+2]:=$B3;
    '': SB[i+2]:=$3D;
    '': SB[i+2]:=$AD;
    '': SB[i+2]:=$3F;
    '': SB[i+2]:=$2F;
    '': SB[i+2]:=$8F;
    '': SB[i+2]:=$1E;
    '': SB[i+2]:=$B5;
    '': SB[i+2]:=$A3;
    '': SB[i+2]:=$BC;
    '': Begin SB[i+2]:=$BC; SB[i+3]:=$0C; Inc(i); end;
    '': SB[i+2]:=$BC;
    '': SB[i+2]:=$B3;
    Else SB[i+2]:=$00;
    End;
    Inc(i);
  End;

  hPos:=10;
  CorrectSB(hPos,CRC);

  SB[11]:=ETX; SB[12]:=ETX xor CRC;
  BytesToSend:=12;
  Session(True);
  DisplayString:=Error;
End;
{}
Function GetState(Com:byte):byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComECRState; SB[3]:=ETX; SB[4]:=ComECRState xor ETX;
  BytesToSend:=4;
  Session(True);
  ConvBCD1ToByte(RB.Cassir);
  ConvBCD1ToByte(RB.ECRNum);
  ConvBCD1ToByte(RB.YY);
  ConvBCD1ToByte(RB.MM);
  ConvBCD1ToByte(RB.DD);
  ConvBCD1ToByte(RB.H);
  ConvBCD1ToByte(RB.M);
  ConvBCD1ToByte(RB.S);
  ConvBCD4ToLongInt(RB.ProdNum);     { ᮢ }
  ConvBCD2ToWord(RB.CheckNum);
  ConvBCD2ToWord(RB.SmenaNum);
  ConvBCD4ToLongInt(RB.CheckSum);
  GetState:=Error;
End;
{}
Function SetTime(Com:Byte;H,M,S:Byte):byte;
Var i,hPos,CRC:Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComSetTime;
  SB[3]:=(h mod 10)+(h div 10)*16;
  SB[4]:=(m mod 10)+(m div 10)*16;
  SB[5]:=(s mod 10)+(s div 10)*16;

  hPos:=5;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  SetTime:=Error;
End;
{}
Function SetDate(Com:Byte;D,M,Y:Byte):byte;
Var i,hPos,CRC:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComSetDate;
  SB[3]:=(D mod 10)+(D div 10)*16;
  SB[4]:=(M mod 10)+(M div 10)*16;
  SB[5]:=(Y mod 10)+(Y div 10)*16;

  hPos:=5;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  SetDate:=Error;
End;
{}
Function GetLastError(Com:Byte; Var LastError:Byte):Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComLastError; SB[3]:=ETX; SB[4]:=ETX xor ComLastError;
  BytesToSend:=4;
  Session(True);
  If Error=errAllOK Then LastError:=-RB.Error;
  GetLastError:=Error;
End;
{}
Function Income(Com:Byte;Sum:LongInt):Byte;
Var i,hPos,CRC:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComIncome;    CRC:=SB[2];
  i:=Sum mod 10000000 div 1000000; SB[3]:=i;          CRC:=CRC xor SB[3];
  i:=Sum mod 1000000 div 100000;   SB[4]:=i;
  i:=Sum mod 100000 div 10000;     SB[4]:=SB[4]*16+i; CRC:=CRC xor SB[4];
  i:=Sum mod 10000 div 1000;       SB[5]:=i;
  i:=Sum mod 1000 div 100;         SB[5]:=SB[5]*16+i; CRC:=CRC xor SB[5];
  i:=Sum mod 100 div 10;           SB[6]:=i;
  i:=Sum mod 10;                   SB[6]:=SB[6]*16+i; CRC:=CRC xor SB[6];

  hPos:=6;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Income:=Error;
End;
{}
Function Outcome(Com:Byte;Sum:LongInt):Byte;
Var i,hPos,CRC:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComOutcome;    CRC:=SB[2];
  i:=Sum mod 10000000 div 1000000; SB[3]:=i;          CRC:=CRC xor SB[3];
  i:=Sum mod 1000000 div 100000;   SB[4]:=i;
  i:=Sum mod 100000 div 10000;     SB[4]:=SB[4]*16+i; CRC:=CRC xor SB[4];
  i:=Sum mod 10000 div 1000;       SB[5]:=i;
  i:=Sum mod 1000 div 100;         SB[5]:=SB[5]*16+i; CRC:=CRC xor SB[5];
  i:=Sum mod 100 div 10;           SB[6]:=i;
  i:=Sum mod 10;                   SB[6]:=SB[6]*16+i; CRC:=CRC xor SB[6];

  hPos:=6;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Outcome:=Error;
End;
{}
Function Discount(Com:Byte;Percent:Byte):Byte;
Begin
End;
{}
Function Upcount(Com:Byte;Percent:Byte):Byte;
Begin
End;
{⨥ 祪  祩 (Money=0 - ᤠ  }
Function CloseCheck(Com, PaymentType: byte; Money: longint): byte;
Var NextPos,j,i,CRC:Byte;
    hPos:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComClose;
  SB[3]:=PaymentType;
  i:=Money mod 10000000 div 1000000; SB[4]:=i;
  i:=Money mod 1000000 div 100000;   SB[5]:=i;
  i:=Money mod 100000 div 10000;     SB[5]:=SB[4]*16+i;
  i:=Money mod 10000 div 1000;       SB[6]:=i;
  i:=Money mod 1000 div 100;         SB[6]:=SB[5]*16+i;
  i:=Money mod 100 div 10;           SB[7]:=i;
  i:=Money mod 10;                   SB[7]:=SB[6]*16+i;

  hPos:=7;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  CloseCheck:=Error;
End;
{ॣ   祪}
Function Reg(Com,Sek: byte; Price: longint; Kol:real): byte;
Var i,CRC:Byte;
    Col:LongInt;
    hPos:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComReg;
  i:=Price mod 10000000 div 1000000; SB[3]:=i;
  i:=Price mod 1000000 div 100000;   SB[4]:=i;
  i:=Price mod 100000 div 10000;     SB[4]:=SB[4]*16+i;
  i:=Price mod 10000 div 1000;       SB[5]:=i;
  i:=Price mod 1000 div 100;         SB[5]:=SB[5]*16+i;
  i:=Price mod 100 div 10;           SB[6]:=i;
  i:=Price mod 10;                   SB[6]:=SB[6]*16+i;

  Col:=Trunc(Kol*1000);
  i:=Col mod 10000000 div 1000000; SB[7]:=i;
  i:=Col mod 1000000 div 100000;   SB[8]:=i;
  i:=Col mod 100000 div 10000;     SB[8]:=SB[8]*16+i;
  i:=Col mod 10000 div 1000;       SB[9]:=i;
  i:=Col mod 1000 div 100;         SB[9]:=SB[9]*16+i;
  i:=Col mod 100 div 10;           SB[10]:=i;
  i:=Col mod 10;                   SB[10]:=SB[10]*16+i;

  SB[11]:=(Sek div 10)*16+(Sek mod 10); CRC:=CRC xor SB[11];

  hPos:=11;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Reg:=Error;
End;
{ॣ  ⨥ 祪}
Function RegWithClose(Com,Sek: byte; Price: longint; Kol:real ): byte;
Begin
  If Reg(Com,Sek,Price,Kol)=errAllOK Then
  RegWithClose:=CloseCheck(Com,1,0) Else
  RegWithClose:=Error;
End;
{ }
Function Total(Com:byte): comp;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComTotal;
  SB[3]:=ETX; SB[4]:=ETX xor SB[2];
  BytesToSend:=4;
  Session(true);
  If Error=errAllOK Then
  Begin
    ConvBCD8ToComp(RB.Money);
    Total:=RB.Money;
  End Else Total:=-1;
End;
{୮}
Function Storno(Com,Sek: byte; Price: longint; Kol:real):Byte;
Var i,CRC:Byte;
    Col:LongInt;
    hPos:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComStorno;
  i:=Price mod 10000000 div 1000000; SB[3]:=i;
  i:=Price mod 1000000 div 100000;   SB[4]:=i;
  i:=Price mod 100000 div 10000;     SB[4]:=SB[4]*16+i;
  i:=Price mod 10000 div 1000;       SB[5]:=i;
  i:=Price mod 1000 div 100;         SB[5]:=SB[5]*16+i;
  i:=Price mod 100 div 10;           SB[6]:=i;
  i:=Price mod 10;                   SB[6]:=SB[6]*16+i;

  Col:=Trunc(Kol*1000);
  i:=Col mod 10000000 div 1000000; SB[7]:=i;
  i:=Col mod 1000000 div 100000;   SB[8]:=i;
  i:=Col mod 100000 div 10000;     SB[8]:=SB[8]*16+i;
  i:=Col mod 10000 div 1000;       SB[9]:=i;
  i:=Col mod 1000 div 100;         SB[9]:=SB[9]*16+i;
  i:=Col mod 100 div 10;           SB[10]:=i;
  i:=Col mod 10;                   SB[10]:=SB[10]*16+i;

  SB[11]:=(Sek div 10)*16+(Sek mod 10); CRC:=CRC xor SB[11];

  hPos:=11;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Storno:=Error;
End;
{}
Function Ret(Com: byte; Price: longint; Kol:real ): byte;
Var i,CRC:Byte;
    Col:LongInt;
    hPos:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComRet;
  i:=Price mod 10000000 div 1000000; SB[3]:=i;
  i:=Price mod 1000000 div 100000;   SB[4]:=i;
  i:=Price mod 100000 div 10000;     SB[4]:=SB[4]*16+i;
  i:=Price mod 10000 div 1000;       SB[5]:=i;
  i:=Price mod 1000 div 100;         SB[5]:=SB[5]*16+i;
  i:=Price mod 100 div 10;           SB[6]:=i;
  i:=Price mod 10;                   SB[6]:=SB[6]*16+i;

  Col:=Trunc(Kol*1000);
  i:=Col mod 10000000 div 1000000; SB[7]:=i;
  i:=Col mod 1000000 div 100000;   SB[8]:=i;
  i:=Col mod 100000 div 10000;     SB[8]:=SB[8]*16+i;
  i:=Col mod 10000 div 1000;       SB[9]:=i;
  i:=Col mod 1000 div 100;         SB[9]:=SB[9]*16+i;
  i:=Col mod 100 div 10;           SB[10]:=i;
  i:=Col mod 10;                   SB[10]:=SB[10]*16+i;

  hPos:=10;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Ret:=Error;
End;
{}
Function RetWithClose(Com: byte; Price: longint; Kol:real ): byte;
Begin
  If Ret(Com,Price,Kol)=errAllOK Then CloseCheck(Com,1,0);
  RetWithClose:=Error;
End;
{㫨஢}
Function Ann(Com: byte; Price: longint; Kol:real ): byte;
Var i,CRC:Byte;
    Col:LongInt;
    hPos:Byte;
    hSB:array[1..SBLen] of Byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComAnn;
  i:=Price mod 10000000 div 1000000; SB[3]:=i;
  i:=Price mod 1000000 div 100000;   SB[4]:=i;
  i:=Price mod 100000 div 10000;     SB[4]:=SB[4]*16+i;
  i:=Price mod 10000 div 1000;       SB[5]:=i;
  i:=Price mod 1000 div 100;         SB[5]:=SB[5]*16+i;
  i:=Price mod 100 div 10;           SB[6]:=i;
  i:=Price mod 10;                   SB[6]:=SB[6]*16+i;

  Col:=Trunc(Kol*1000);
  i:=Col mod 10000000 div 1000000; SB[7]:=i;
  i:=Col mod 1000000 div 100000;   SB[8]:=i;
  i:=Col mod 100000 div 10000;     SB[8]:=SB[8]*16+i;
  i:=Col mod 10000 div 1000;       SB[9]:=i;
  i:=Col mod 1000 div 100;         SB[9]:=SB[9]*16+i;
  i:=Col mod 100 div 10;           SB[10]:=i;
  i:=Col mod 10;                   SB[10]:=SB[10]*16+i;

  hPos:=10;
  CorrectSB(hPos,CRC);

  SB[hPos+1]:=ETX; SB[hPos+2]:=ETX xor CRC;
  BytesToSend:=hPos+2;
  Session(True);
  Ann:=Error;
End;
{㫨஢ 祪}
Function AnnCheck(Com: byte): byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComAnnCheck;
  SB[3]:=ETX; SB[4]:=ETX xor SB[2];
  BytesToSend:=4;
  Session(true);
  AnnCheck:=Error;
End;
{஬ ⮣}
Function PS(Com:byte): byte;
Begin
  Init(Com);
  SB[1]:=STX; SB[2]:=ComSub; SB[3]:=ETX; SB[4]:=ETX xor SB[2];
  BytesToSend:=4;
  Session(True);
  If Error=errAllOK Then PS:=-RB.Error
  Else PS:=Error;
End;
{  祪}
Function NumCheck(Com:byte): longint;
begin
  GetState(Com);
  if Error=errAllOK Then NumCheck:=RB.CheckNum
  Else NumCheck:=Error;
end;
{  }
Function NumZaw(Com:byte): longint;
begin
  GetState(Com);
  if Error=errAllOK Then NumZaw:=RB.ProdNum
  Else NumZaw:=Error;
end;

End.





